import { Hono } from "hono";
import { Counter, Gauge, Registry,  } from "prom-client";
// import { kv } from "../lib/helpers/youtubePlayerHandling.ts";

const metrics = new Hono();
const METRICS_PREFIX = "invidious_companion_";
export const register = new Registry();

function createCounter(name: string, help?: string): Counter {
    return new Counter({
        name: `${METRICS_PREFIX}${name}`,
        help: help || "TODO",
        registers: [register],
    });
}

export const cachedEntries = new Gauge({
    name: `${METRICS_PREFIX}cached_entries`,
    help: "TODO",
    registers: [register],
});

export const externalTokenGeneratorFail = createCounter(
    "externaltokengenerator_fail",
);
export const subreasonProtectCommunity = createCounter(
    "subreason_protect_community",
);
export const poTokenFail = createCounter("potoken_fail");
export const reasonBot = createCounter("reason_bot", "TODO");
export const videoUnavailable = createCounter("video_unavailable", "TODO");
export const videoRestricted = createCounter("video_restricted", "TODO");
export const failedRequests = createCounter("failed_requests", "TODO");
export const successfulRequests = createCounter("successful_requests", "TODO");
export const retryCount = createCounter("retry_count", "TODO");

metrics.get("/", async () => {
    // let i = 0;
    // const entries = kv.list({ prefix: ["video_cache"] });
    // for await (const _ of entries) {
    //     i += 1;
    // }
    // cachedEntries.set(i);
    return new Response(await register.metrics(), {
        headers: { "Content-Type": "text/plain" },
    });
});

export default metrics;
